org.apache.lucene.queryparser.flexible.standard.parser

## Interface CharStream

- All Known Implementing Classes:
    FastCharStream

      public interface CharStream

  This interface describes a character stream that maintains line and column number positions of the characters. It also has the capability to backup the stream to some extent. An implementation of this interface is used in the TokenManager implementation generated by JavaCCParser. All the methods except backup can be implemented in any fashion. backup needs to be implemented correctly for the correct operation of the lexer. Rest of the methods are all used to get information like line number, column number and the String that constitutes a token and are not used by the lexer. Hence their implementation won't affect the generated lexer's operation.

- - ### Method Summary

    All Methods Instance Methods Abstract Methods Deprecated Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `backup(int amount)` Backs up the input stream by amount steps.
    `char` | `BeginToken()` Returns the next character that marks the beginning of the next token.
    `void` | `Done()` The lexer calls this function to indicate that it is done with the stream and hence implementations can free any resources held by this class.
    `int` | `getBeginColumn()` Returns the column number of the first character for current token (being matched after the last call to BeginTOken).
    `int` | `getBeginLine()` Returns the line number of the first character for current token (being matched after the last call to BeginTOken).
    `int` | `getColumn()` Deprecated.
    `int` | `getEndColumn()` Returns the column number of the last character for current token (being matched after the last call to BeginTOken).
    `int` | `getEndLine()` Returns the line number of the last character for current token (being matched after the last call to BeginTOken).
    `String` | `GetImage()` Returns a string made up of characters from the marked token beginning to the current buffer position.
    `int` | `getLine()` Deprecated.
    `char[]` | `GetSuffix(int len)` Returns an array of characters that make up the suffix of length 'len' for the currently matched token.
    `char` | `readChar()` Returns the next character from the selected input.

- - ### Method Detail

    - #### readChar

          char readChar()
                 throws IOException

      Returns the next character from the selected input. The method of selecting the input is the responsibility of the class implementing this interface. Can throw any java.io.IOException.
      Throws:
        `IOException`

    - #### getColumn

          @Deprecated
          int getColumn()

      Deprecated.

    - #### getLine

          @Deprecated
          int getLine()

      Deprecated.

    - #### getEndColumn

          int getEndColumn()

      Returns the column number of the last character for current token (being matched after the last call to BeginTOken).

    - #### getEndLine

          int getEndLine()

      Returns the line number of the last character for current token (being matched after the last call to BeginTOken).

    - #### getBeginColumn

          int getBeginColumn()

      Returns the column number of the first character for current token (being matched after the last call to BeginTOken).

    - #### getBeginLine

          int getBeginLine()

      Returns the line number of the first character for current token (being matched after the last call to BeginTOken).

    - #### backup

          void backup(int amount)

      Backs up the input stream by amount steps. Lexer calls this method if it had already read some characters, but could not use them to match a (longer) token. So, they will be used again as the prefix of the next token and it is the implemetation's responsibility to do this right.

    - #### BeginToken

          char BeginToken()
                   throws IOException

      Returns the next character that marks the beginning of the next token. All characters must remain in the buffer between two successive calls to this method to implement backup correctly.
      Throws:
        `IOException`

    - #### GetImage

          String GetImage()

      Returns a string made up of characters from the marked token beginning to the current buffer position. Implementations have the choice of returning anything that they want to. For example, for efficiency, one might decide to just return null, which is a valid implementation.

    - #### GetSuffix

          char[] GetSuffix(int len)

      Returns an array of characters that make up the suffix of length 'len' for the currently matched token. This is used to build up the matched string for use in actions in the case of MORE. A simple and inefficient implementation of this is as follows : { String t = GetImage(); return t.substring(t.length() - len, t.length()).toCharArray(); }

    - #### Done

          void Done()

      The lexer calls this function to indicate that it is done with the stream and hence implementations can free any resources held by this class. Again, the body of this function can be just empty and it will not affect the lexer's operation.

Copyright © 2000-2018 Apache Software Foundation. All Rights Reserved.